<?
/**
Genera in automatico il file sitemap.xml per google

vedi : http://www.google.com/webmasters/sitemaps/docs/it/protocol.html

@author Alessandro Vernassa

**/


if (isset($_GET['updatesitemap']))
{
	if (is_writable("."))
	{
		write_sitemap("sitemap.xml");	
		echo "<br>Sitemap.xml created</br>";
	}
	else
		echo "<br>Directory is readonly</br>";




}


/**
 * Stampa la lista delle sezioni e delle sottosessioni su un file
 *
 * @param string $path dove cercare la sezione (es. sections/01_pippo)
 * @param string $indexpath path del file da scrivere
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */
function printsitemaptofile($path,$indexpath,$lang=null)
{
	$sBasePath = $url = "http://".$_SERVER["HTTP_HOST"].DirName($_SERVER['PHP_SELF']);

	global $theme;
	$modlist= list_sections($path);
	
	foreach ($modlist as $mod)
	{
		$handle=fopen ($indexpath,"a");
		if(stristr($mod,"_"))
		{
			$tmp=eregi_replace("^[0-9][0-9]_","",$mod);
			$tmp=str_replace("_","&nbsp;",$tmp);
		}
		else
			$tmp=$mod;
			if (file_exists("$path/$mod/lang.xml"))
		{
			$tmp=getLang("$path/$mod/lang.xml",$tmp,$lang);
		}
			
		if ($path!="sections/")
			fwrite($handle, "<url>\n\t<loc>$sBasePath/index.php?mod=".str_replace("sections//","",$path)."/$mod&amp;lang=$lang\n</loc>\n</url>\n");
		else
			fwrite($handle, "<url>\n\t<loc>$sBasePath/index.php?mod=$mod&amp;lang=$lang</loc>\n</url>\n");
		
		fclose($handle);
		printsitemaptofile("$path/$mod",$indexpath,$lang);
	}
}


/**
 * Genera un file html statico con la mappa del sito
 * Utile per indicizzare dai motori di ricerca le 
 * pagine php.
 *
 * @param string $indexpath path del file da scrivere
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */

function write_sitemap($indexpath)
{
	$sBasePath = 	$url = "http://".$_SERVER["HTTP_HOST"].DirName($_SERVER['PHP_SELF']);
	include('config.php');
	$handle=fopen ($indexpath,"w");

	fwrite($handle, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n");
	fclose($handle);
	$list_languages=explode(",",$languages);
	foreach ($list_languages as $langw)
	{
		printsitemaptofile("sections/",$indexpath,$langw);
	}
	$handle=fopen ($indexpath,"a");
	fwrite($handle, "\n</urlset>");
	fclose($handle);
}

?>